config/urls.py
from django.conf import settings

from django.urls import re_path, include

from django.contrib import admin
from django.contrib.auth.views import LogoutView
from django.views.generic import TemplateView

# Import feeds
import core.views
from events.feeds import EventFeed, feedview
import events.reports
import events.views
from ligoauth.views import (
    manage_password, ShibLoginView, ShibPostLoginView
)
import search.views

# Django admin auto-discover
admin.autodiscover()

feeds = {
    'latest' : EventFeed
}


urlpatterns = [
    re_path(r'^$', events.views.index, name="home"),
    re_path(r'^navbar_only$', TemplateView.as_view(
        template_name='navbar_only.html'), name="navbar-only"),
    re_path(r'^SPInfo', TemplateView.as_view(template_name='gracedb/spinfo.html'),
         name="spinfo"),
    re_path(r'^SPPrivacy', TemplateView.as_view(
        template_name='gracedb/spprivacy.html'), name="spprivacy"),
    re_path(r'^DiscoveryService', TemplateView.as_view(
        template_name='discovery.html'), name="discovery"),
    re_path(r'^events/', include('events.urls')),
    re_path(r'^superevents/', include('superevents.urls')),
    re_path(r'^alerts/', include('alerts.urls')),
    re_path(r'^feeds/(?P<url>.*)/$', EventFeed()),
    re_path(r'^feeds/$', feedview, name="feeds"),

    re_path(r'^other/$', TemplateView.as_view(template_name='other.html'),
        name='other'),
    re_path(r'^performance/$', events.views.performance, name="performance"),
    re_path(r'^reports/$', events.reports.histo, name="reports"),
    re_path(r'^latest/$', search.views.latest, name="latest"),
    #(r'^reports/(?P<path>.+)$', 'django.views.static.serve',
    #        {'document_root': settings.LATENCY_REPORT_DEST_DIR}),
    re_path(r'^search/$', search.views.search, name="mainsearch"),

    # Authentication
    re_path(r'^login/$', ShibLoginView.as_view(), name='login'),
    re_path(r'^post-login/$', ShibPostLoginView.as_view(), name='post-login'),
    re_path(r'^logout/$', LogoutView.as_view(), name='logout'),

    # Password management
    re_path('^manage-password/$', manage_password, name='manage-password'),

    # API URLs
    re_path(r'^api/', include('api.urls')),
    # Legacy API URLs - must be maintained!
    re_path(r'^apibasic/', include('api.urls', namespace='legacy_apibasic')),
    re_path(r'^apiweb/', include('api.urls', namespace='legacy_apiweb')),

    # Heartbeat URL
    re_path(r'^heartbeat/$', core.views.heartbeat, name='heartbeat'),

    # Uncomment the admin/doc line below and add 'django.contrib.admindocs'
    # to INSTALLED_APPS to enable admin documentation:
    # (r'^admin/doc/', include('django.contrib.admindocs.urls')),
    re_path(r'^admin/', admin.site.urls),

    # Sessions
    re_path(r'^', include('user_sessions.urls', 'user_sessions')),

]

# We don't require settings.DEBUG for django-silk since running unit tests
# by default setings settings.DEBUG to False, unless you use the
# --debug-mode flag
if ('silk' in settings.INSTALLED_APPS):
    # Add django-silk
    urlpatterns = [
        re_path(r'^silk/', include('silk.urls', namespace='silk'))
    ] + urlpatterns

# Add django-debug-toolbar
if settings.DEBUG and 'debug_toolbar' in settings.INSTALLED_APPS:
    import debug_toolbar
    urlpatterns = [
        re_path(r'^__debug__/', include(debug_toolbar.urls)),
    ] + urlpatterns

gracedb/alerts/urls.py
from django.urls import re_path

from . import views

app_name = 'alerts'


urlpatterns = [
    # Base /options/ URL
    re_path(r'^$', views.index, name="index"),

    # Contacts
    re_path(r'^contact/create/', views.CreateContactView.as_view(),
        name='create-contact'),
    re_path(r'^contact/(?P<pk>\d+)/edit/$', views.EditContactView.as_view(),
        name="edit-contact"),
    re_path(r'^contact/(?P<pk>\d+)/delete/$', views.DeleteContactView.as_view(),
        name="delete-contact"),
    re_path(r'^contact/(?P<pk>\d+)/test/$', views.TestContactView.as_view(),
        name="test-contact"),
    re_path(r'^contact/(?P<pk>\d+)/request-code/$',
        views.RequestVerificationCodeView.as_view(),
        name="request-verification-code"),
    re_path(r'^contact/(?P<pk>\d+)/verify/$', views.VerifyContactView.as_view(),
        name="verify-contact"),

    # Notifications
    re_path(r'^notification/create/$', views.CreateNotificationView.as_view(),
        name="create-notification"),
    re_path(r'^notification/(?P<pk>\d+)/edit/$',
        views.EditNotificationView.as_view(), name="edit-notification"),
    re_path(r'^notification/(?P<pk>\d+)/delete/$',
        views.DeleteNotificationView.as_view(), name="delete-notification"),
]

gracedb/api/urls.py
from django.urls import re_path, include

from .v1 import urls as v1_urls
from .v2 import urls as v2_urls

app_name = 'api'

urlpatterns = [
    re_path(r'^', include((v1_urls, 'default'))),
    re_path(r'^v1/', include((v1_urls, 'v1'))),
    re_path(r'^v2/', include((v2_urls, 'v2'))),
]

gracedb/core/urls.py
# URL utilities

from django.contrib.sites.models import Site


def build_absolute_uri(relative_uri, request=None):
    if request is not None:
        return request.build_absolute_uri(relative_uri)
    else:
        # Assume HTTPS
        domain = Site.objects.get_current().domain
        return 'https://' + domain + relative_uri

# A helper function to return superevent urls from /api/-->/apiweb/
# Note that event files are never exposed to the public and so aren't 
# subject to the same private api vs public apiweb caching schemes
def build_apiweb_uri(relative_uri, request=None):
    absolute_uri = build_absolute_uri(relative_uri, request=request)

    # Return the apiweb url for superevents:
    if '/superevents/' in absolute_uri:
        absolute_uri = absolute_uri.replace('/api/', '/apiweb/')

    return absolute_uri

gracedb/superevents/urls.py
from django.conf.urls import url, include
from django.urls import path
from .models import Superevent
from . import views

app_name = 'superevents'


# URLs which are nested below a superevent detail
# These are included under a superevent's ID URL prefix (see below)
suburlpatterns = [

    # Superevent detail view
    url(r'^view/$', views.SupereventDetailView.as_view(), name="view"),

    # File list (file detail/download is handled through the API)
    url(r'^files/$', views.SupereventFileList.as_view(), name="file-list"),
]

# Legacy URL patterns - don't really need them, but we use them for the
# convenience of users who may be accustomed to the legacy event URL patterns

# public page url patterns. This needs to go first so django matches 
# the 'public' string before parsing it interprets it as a superevent_id.
# Note to future generations: don't name a GW 'public' or the link breaks.

public_urlpatterns = [
    # The /superevents/public/ url route gets redirected to the 
    # latest observation run.
    path('public/', views.public_alerts_redirect,
        name="public-alerts-redirect"),

    # each run has its own page, but must be in the list of runs that's 
    # in settings/base.py. Otherwise, 404 (this gets defined in the view). 
    # the "obsrun" variable controls which events are shown.
     path('public/<slug:obsrun>/', views.SupereventPublic.as_view(),
         name="public-alerts"),

]
legacy_urlpatterns = public_urlpatterns + [
    # Legacy URLs for superevent detail view
    path('<str:superevent_id>/',
        views.SupereventDetailView.as_view(),
        name="legacyview1"),
    path('view/<str:superevent_id>/',
        views.SupereventDetailView.as_view(),
        name="legacyview2"),
]

# Full urlpatterns: legacy urls plus suburlpatterns nested under
# superevent_id
urlpatterns = legacy_urlpatterns + [
    path('<str:superevent_id>/',
        include(suburlpatterns)),

]

gracedb/core/models.py
from collections import OrderedDict
import logging

from django.db import models, connection, IntegrityError
from django.db.models import Q, Max
from django.conf import settings
from django.contrib.auth import get_user_model
from django.core.exceptions import ValidationError
from django.db.models import QuerySet
from django.forms.models import model_to_dict
from django.utils.translation import gettext_lazy as _

from core.vfile import VersionedFile

# Testing waiting:
from time import sleep
from random import random

DB_SLEEP_FACTOR = settings.DB_SLEEP_FACTOR

# Set up user model
UserModel = get_user_model()

# Set up logger
logger = logging.getLogger(__name__)


class CleanSaveModel(models.Model):
    """Abstract model which automatically runs full_clean() before saving"""

    class Meta:
        abstract = True

    def save(self, *args, **kwargs):
        self.full_clean()
        super(CleanSaveModel, self).save(*args, **kwargs)


class AutoIncrementModel(models.Model):
    """
    An abstract class used as a base for classes which need the
    autoincrementing save method described below.

    AUTO_FIELD: name of field which acts as an autoincrement field.
    AUTO_CONSTRAINTS: tuple of field names to use as a constraint; i.e., the
                      AUTO_FIELD increments relative to the number of rows in
                      the table which have the same values for these fields.
    """
    AUTO_FIELD = None
    AUTO_CONSTRAINTS = None
    max_retries = 5

    class Meta:
        abstract = True

    def save(self, *args, **kwargs):

        # Do a normal save if this is not an insert (i.e., the instance has a
        # primary key already), or if the required fields are not set
        pk_set = self._get_pk_val() is not None
        if (pk_set or (self.AUTO_FIELD is None or
                       self.AUTO_CONSTRAINTS is None)):
            super(AutoIncrementModel, self).save(*args, **kwargs)
        else:
            self.auto_increment_insert(*args, **kwargs)

    def auto_increment_insert(self, *args, **kwargs):
        """

        This has been tested with the following classes:
            EventLog, EMObservation, EMFootprint, EMBBEventLog, VOEvent


        Requires AUTO_FIELD and AUTO_CONSTRAINTS to be defined.
        """

        # Check for the existence of the required fields:
        if not self.AUTO_CONSTRAINTS or not self.AUTO_FIELD:
            raise TypeError('AUTO_CONSTRAINTS or AUTO_FIELD not set.')

        # Check type of self.AUTO_CONSTRAINTS
        if not isinstance(self.AUTO_CONSTRAINTS, (tuple, list)):
            raise TypeError(_('AUTO_CONSTRAINTS should be a tuple or list'))


        # Get some useful information
        meta = self.__class__._meta
        current_class = self.__class__

        # Get model fields, except for primary key field.
        fields = [f for f in meta.local_concrete_fields if not
            isinstance(f, models.fields.AutoField)]

        # Check constraint fields
        f_names = [f.name for f in fields]
        for constraint_field in self.AUTO_CONSTRAINTS:
            if constraint_field not in f_names:
                raise ValueError(_(('Constraint {0} is not a field for '
                    'model {1}').format(constraint_field,
                    current_class.__name__)))

        # Check auto field
        if self.AUTO_FIELD not in f_names:
            raise ValueError(_(('AUTO_FIELD {0} is not a field for '
                'model {1}').format(self.auto_field, self.__class__.__name__)))


        # Set up Q query for multiple constraints. For instance, superevents'
        # base_date_number is constrained by both category and the date. So
        # for example, there can exist S123456a, TS123456a, and MS123456a. The
        # t_0_date is the same, but the category is different. So they each get
        # an "a". 

        const_query = Q()
        for const in self.AUTO_CONSTRAINTS:
            const_query = const_query & Q(**{const: getattr(self, const)})


        # Set AUTO_FIELD to one-plus-the-maximum of the value of AUTO_FIELD
        # in the constained set. Note that since some superevents get removed
        # or other circumstances, the max does not always equal to the number 
        # entries in the set. This caused some db integrity errors in testing.

        # Save object and check constraints. Add ability to retry on the event
        # of DB Integrity errors. 

        number_of_tries = 0
        success = False
        while not success:
            try:
                setattr(self, self.AUTO_FIELD,
                        self.updated_autofield_value(current_class, const_query))
                super(AutoIncrementModel, self).save(*args, **kwargs)
            except (IntegrityError, ValidationError):
                logger.warning("Sleeping to stabilize database. try= {}, object={}".format(number_of_tries, self))
                sleep(DB_SLEEP_FACTOR * random())
                number_of_tries += 1
                if number_of_tries > 6:
                    raise
            else:
                success = True

    def updated_autofield_value(self, current_class, query):
        # get the queryset:
        query_set = current_class.objects.filter(query)
        if query_set:
            return query_set.aggregate(max_val=Max(self.AUTO_FIELD))['max_val'] + 1
        else:
            return 1

    def auto_increment_update(self, update_field_name, constraints=[],
        allow_update_to_nonnull=False):
        """
        UPDATE superevents_superevent SET gw_date_number = (SELECT N FROM (SELECT IFNULL(MAX(gw_date_number),0)+1 as N FROM superevents_superevent WHERE t_0_date='1980-01-06' AND is_gw=1) AS y) WHERE id=41;
        """

        if (not allow_update_to_nonnull and getattr(self, update_field_name)
            is not None):
            raise ValueError(_(('Attempt to update a non-null constrained auto'
                'field for object {0}. Not allowed.').format(self.__str__())))

        # Get current class:
        current_class = self.__class__

        # Set up query based on the constraints:
        query = Q()
        for i in constraints:
            query = query & Q(**{i: getattr(self, i)})

        # get the queryset that meets the constraints:

        qs = current_class.objects.filter(query)

        # Set AUTO_FIELD to one-plus-the-maximum of the value of AUTO_FIELD
        # in the constained set. Note that since some superevents get removed
        # or other circumstances, the max does not always equal to the number
        # entries in the set. This caused some db integrity errors in testing.

        if qs:
            try:
                setattr(self, update_field_name,
                        qs.aggregate(max_val=Max(update_field_name))['max_val'] + 1)
            # Add exception for cases where the update field wasn't
            # initially...updated:
            except TypeError:
                setattr(self, update_field_name, 1)
        else:
            setattr(self, update_field_name, 1)


class LogBase(models.Model):
    """
    Abstract base class for log message-type objects. Concrete derived
    classes will probably want to add a ForeignKey to another model.

    Used in events.EventLog, superevents.Log
    """
    created = models.DateTimeField(auto_now_add=True)
    issuer = models.ForeignKey(UserModel, null=False, on_delete=models.CASCADE)
    filename = models.CharField(max_length=100, default="", blank=True)
    file_version = models.IntegerField(null=True, default=None, blank=True)
    comment = models.TextField(null=False)
    N = models.IntegerField(null=False, editable=False)

    class Meta:
        abstract = True
        ordering = ['-created', '-N']
        indexes = [models.Index(fields=['filename', ])]

    @property
    def versioned_filename(self):
        if self.filename:
            actual_filename = self.filename
            if self.file_version is not None:
                actual_filename += ",{n}".format(n=self.file_version)
        else:
            actual_filename = None
        return actual_filename

    def fileurl(self):
        # Override this on derived classes
        return NotImplemented

    def hasImage(self):
        # XXX hacky
        IMAGE_EXT = ['png', 'gif', 'jpg']
        return (self.filename and self.filename[-3:].lower() in IMAGE_EXT)

    @staticmethod
    def split_versioned_filename(versioned_name):
        filename, version = VersionedFile.split_versioned_name(versioned_name)
        return filename, version


class m2mThroughBase(models.Model):
    """
    Abstract base class which is useful for providing "through" access for a
    many-to-many relationship and recording the relationship creator and
    creation time.
    """
    creator = models.ForeignKey(UserModel, null=False, related_name=
        '%(app_label)s_%(class)s_set', on_delete=models.CASCADE)
    created = models.DateTimeField(auto_now_add=True)

    class Meta:
        abstract = True

gracedb/superevents/forms.py
import logging
import os

from django import forms

from superevents.models import Signoff

# Set up logger
logger = logging.getLogger(__name__)


class SignoffForm(forms.ModelForm):

    class Meta:
        model = Signoff
        fields = ['status', 'comment', 'signoff_type', 'instrument']

    def __init__(self, *args, **kwargs):
        super(SignoffForm, self).__init__(*args, **kwargs)
        # Hide some fields that we will populate either by default
        # when we instantiate the form or with the request data
        self.fields['signoff_type'].widget = forms.HiddenInput()
        self.fields['instrument'].widget = forms.HiddenInput()

gracedb/api/v2/events/views.py
from ...v1.events.views import *

gracedb/api/v2/main/views.py
from ...v1.main.views import *

gracedb/api/v2/superevents/views.py
from ...v1.superevents.views import *

gracedb/templates/gracedb/cbc_report.html
{% extends "base.html" %}
{% load scientific %}
{% load timeutil %}

{% block bodyattrs %}
onload="document.search_form.query.focus();"
{% endblock %}

{% block title %}CBC Report{% endblock %}
{% block heading %}{% endblock %} #}
{% block pageid %}CBC Report{% endblock %}

{% block content %}

<div class="content-area">

    {% if message %}
    <p><font color="red"> {{ message }} </font> </p>
    {% endif %}

    <form method="POST" name="search_form">
      <table>
        {{ form.as_table }}
        <tr><td/><td><a href="/documentation/queries.html">Query help</a>
      </table>
    </form>

    {{ title }}
</div>

{% if count > 0 %}
<div class="content-area">
    <h3> IFAR Plot  </h3>
    <div>
        <img src="data:image/png;base64,{{ ifar_plot|safe }}"></img>
    </div>
</div>

<div class="content-area">
    <h3> Mass Distributions </h3>
    <div>
        <img src="data:image/png;base64,{{ mchirp_dist|safe }}"></img>
    </div>

    <div>
        <img src="data:image/png;base64,{{ mass_dist|safe }}"></img>
    </div>
</div>

<div class="content-area">
    <h3> Loudest event table </h3>

    <!-- legend table -->
    <br/>
    <br/>
    <table style="border-spacing:0px;">
        {% for d in FAR_color_map %}
        <tr> <td style="background-color:{{ d.color }}">{{ d.desc }}</td> </tr>
        {% endfor %}
    </table>
    <br/>
    <br/>

    <table class="gstlalcbc">
        <!-- need to select background color based on far. Ucky? -->
        <tr>
            <th>Rank</th>
            <th>GraceID</th>
            <th>gpstime</th>
            <th>FAR</th>
            <th>IFOs</th>
            <th>Total Mass</th>
            <th>Chirp Mass</th>
            <th>SNR</th>
        </tr>
        {% for obj in clustered_events %}
            {% for d in FAR_color_map %}
                {%if obj.far <= d.max_far and obj.far > d.min_far %}
                <tr style="background-color:{{d.color}}">
                {% endif %}
            {% endfor %}
            <td>{{ forloop.counter }} </td>
            <td><a href="{% url "view" obj.graceid %}">{{ obj.graceid }}</a></td>
            <td> {{ obj|end_time }} </td>
            <td> {{ obj.far|scientific }} </td>
            <td> {{ obj.instruments }} </td>
            <td> {{ obj.mass|floatformat:4 }} </td>
            <td> {{ obj.mchirp|floatformat:4 }} </td>
            <td> {{ obj.snr|floatformat:4 }} </td>
        </tr>
        {% endfor %}
    </table>
</div>

{% endif %}

{% endblock %}

gracedb/templates/gracedb/eel_detail.html
{% extends "base.html" %}

{% block title %}Electromagnetic Bulletin Board{% endblock %}
{% block heading %}EMBBEventLog Detail{% endblock %}
{% block pageid %}eel_detail{% endblock %}

{% block content %}

<div class="text">

<p>
This will be the eel detail page.
</p>

</div>

{% endblock %}

gracedb/templates/gracedb/event_detail_coinc_ext.html
{% extends "gracedb/event_detail.html" %}
{% load timeutil %}
{% load scientific %}

{# Analysis-specific attributes for an LM event#}
{% block external_analysis_specific %}

{# Test whether the object has the end_time property. Older (non CoincInspiral) events don't. #}
{% if object.end_time %}

<div id="container" style="display:table;width:100%">
<div style="display:table-row;width:100%">

<div style="display:table-cell;float:left;width:35%;">

{% if single_inspiral_events %}
<!-- Single Inspiral Data -->
<div style="display:table-cell;float:right;width:65%">
<h2>Single Inspiral Tables</h2>

<!--<div id="single_inspiral_tables"> -->
<!-- <div id="single_inspiral_tables"
       	data-dojo-type="dijit/TitlePane"
        data-dojo-props="title: 'Single Inspiral Tables', open: false"> -->
        <!--<table class="analysis_specific_lm"> -->
<table>
	<tr>
		<th>IFO</th>
		{% for e in single_inspiral_events %}
		<th>{{ e.ifo }}</th>
		{% endfor %}
	</tr>
	<tr>
		<th>End Time (GPS)</th>
		{% for e in single_inspiral_events %}
		<td>{{ e.end_time_full }}&nbsp;s</td>
		{% endfor %}
	</tr>
</table>
</div> 


{% endif %} <!-- if single_inspiral_events -->

</div>
</div> <!-- container -->
{% endif %} <!-- object has end_time property. -->

{% endblock %}

gracedb/templates/gracedb/event_detail_oLIB.html
{% extends "gracedb/event_detail.html" %}

{%load scientific %}

{# Analysis-specific attributes for a cWB event#}
{% block analysis_specific %}

<div class="row my-3 justify-content-md-center">
    <div class="col-md-10">
        <div id="table-coinc-event">
            <table class="table-hover table-condensed table-resp-gracedb shadow p-3 mb-5 rounded">
                <thead>
                    <tr>
                        <th colspan="2"><h3>Omicron SNR</h3></th>
                    </tr>
                </thead>
                <tr> <td> Network </td> <td> {{object.omicron_snr_network|floatformat:"-4"}} </td> </tr> 
                <tr> <td> H1 </td> <td> {{object.omicron_snr_H1|floatformat:"-4"}} </td> </tr> 
                <tr> <td> L1 </td> <td> {{object.omicron_snr_L1|floatformat:"-4"}} </td> </tr> 
                <tr> <td> V1 </td> <td> {{object.omicron_snr_V1|floatformat:"-4"}} </td> </tr> 
            </table>
        </div>
    </div>
</div>

<div class="row my-3 justify-content-md-center">
    <div class="col-md-10">
        <div id="table-coinc-event">
            <table class="table-hover table-condensed table-resp-gracedb shadow p-3 mb-5 rounded">
                <thead>
                   <tr> <th colspan="3"><h3>Posteriors</h3></th></tr>
                   <tr> <th></th><th>Mean</th><th>Median</th></tr>

                </thead>
                <tr> <td> Frequency (Hz) </td> <td>{{object.frequency_mean|floatformat:"-4"}}</td> <td>{{object.frequency_median|floatformat:"-4"}}</td> </tr> 
                <tr> <td> hrss </td> <td>{{object.hrss_mean|scientific}}           </td> <td>{{object.hrss_median|scientific}} </td> </tr> 
                <tr> <td> Quality </td> <td>{{object.quality_mean|floatformat:"-4"}}  </td> <td>{{object.quality_median|floatformat:"-4"}}</td> </tr> 
            </table>
        </div>
    </div>
</div>

<div class="row my-3 justify-content-md-center">
    <div class="col-md-10">
        <div id="table-coinc-event">
            <table class="table-hover table-condensed table-resp-gracedb shadow p-3 mb-5 rounded">
                <thead>
                    <tr>
                        <th colspan="2"><h3>Additional oLIB Data</h3></th>
                    </tr>
                </thead>
                <tr> <td> BCI </td> <td> {{object.bci|floatformat:"-4"}} </td> </tr> 
                <tr> <td> BSN </td> <td> {{object.bsn|floatformat:"-4"}} </td> </tr> 
            </table>
        </div>
    </div>
</div>

{% endblock %}

gracedb/templates/gracedb/index.html
{% extends "base.html" %}
{% block title %}The Gravitational-Wave Candidate Event Database{% endblock %}
{% block heading %}{% endblock %}
{% block pageid %}home{% endblock %}
{% block jscript %}
{% endblock %}

{% block content %}

  <h5>GraceDB Overview</h5>
    <hr>
    <p >
    The <b>Gra</b>vitational-Wave <b>C</b>andidate <b>E</b>vent <b>D</b>ata<b>b</b>ase (<b>GraceDB</b>) is a service operated by the <a href="https://www.ligo.org/">LIGO Scientific Collaboration</a>. It provides a centralized location for aggregating and retrieving information about candidate gravitational-wave events. GraceDB provides an <a href="{% url "legacy_apiweb:default:root" %}">API</a> for programmatic access, and a <a href="https://ligo-gracedb.readthedocs.io/">client package</a> is available for interacting with the API.
    </p>
    <!--
    <div style="border:3px; border-style:solid; border-color:#FF0000; padding:
        1.25em; border-radius: 10px;">
    <b> Attention LVK Users: </b> As of October 2022, LVAlert has been
    decomissioned and replaced by <a href="https://git.ligo.org/computing/igwn-alert/client"><span
                                class="text-monospace">igwn-alert</span></a>.
    For more information on transitioning your workflows, please consult:
    <li> <a href="https://computing.docs.ligo.org/igwn-alert/client/lvalert_to_igwnalert.html">
            The LVAlert to igwn-alert transition guide </a></li>
    <li><a href="https://computing.docs.ligo.org/igwn-alert/client/guide.html">The
            igwn-alert User Guide </a></li>
    </div> -->
    <br>
   <h5>Useful information</h5>
    <hr>
    <li >Information about GW alerts and real-time data products is available in the <a href="https://emfollow.docs.ligo.org/userguide/">LIGO/Virgo Public Alert Guide</a>.</li>
    <li ><a href="https://monitor.ligo.org/ldg">Real-time status of the LIGO Data Grid</a>.</li>
    <li >Need help? Send an email to <a
            href="mailto:computing-help@igwn.org">computing-help@igwn.org</a>,
        or LIGO/Virgo users can report issues on the GraceDB <a
                                                                 href="https://git.ligo.org/computing/gracedb/server/issues">Gitlab page</a>.</li>
    </ul>
    <br>
{% if information %}
    {{ information|safe }}
{% endif %}
     <br>
    <p ><small><b>Server code version: </b> <a
            href="https://git.ligo.org/computing/gracedb/server/-/tree/gracedb-{{server_version}}" class="text-monospace" >{{server_version}}</a></p></small>

<!--XXX Infrastructure for human signoffs. Hopefully this will not be permanent. -->
{% if signoff_authorized %}
    {% if signoff_superevent_ids|length or new_signoff_graceids|length or older_signoff_graceids|length %}
    <div class="signoff-area">
    <h2>Attention {{signoff_instrument}} Operator</h2>
    <br />
    {% if signoff_superevent_ids|length %}
        <h3>The following superevents require your signoff:</h3>
        {% if signoff_superevent_ids|length %}
        <ul>
        {% for s_id in signoff_superevent_ids %}
            <li><a href="{% url "superevents:view" s_id %}">{{ s_id }}</a></li>
        {% endfor %}
        </ul>
        {% endif %}
    {% endif %}
    {% if new_signoff_graceids|length or older_signoff_graceids|length %}
        <h3>The following events require your sign-off:</h3>
        {% if new_signoff_graceids|length %}
        <p>Events submitted within the last 24 hours:</p>
        <ul>
        {% for graceid in new_signoff_graceids %}
            <li><a href="{% url "view" graceid %}">{{ graceid }}</a></li>
        {% endfor %} 
        </ul>
        {% endif %}
        {% if older_signoff_graceids|length %}
        <p>Events older than 24 hours:</p>
        <ul>
        {% for graceid in older_signoff_graceids %}
            <li><a href="{% url "view" graceid %}">{{ graceid }}</a></li>
        {% endfor %}
        </ul>
        {% endif %}
    {% endif %}
    <p>Please click on the link(s) above and use the form at the top of the page.</p>
    </div>
    {% endif %}
{% endif %}


{% endblock %}